<template>
    <div class="details-page" v-if="hasToken">
        <el-button type="text" class="details-page__back" @click="goBack()">
            <i class="el-icon-d-arrow-left">BACK</i>
        </el-button>
        <template v-if="dataIsLoaded">
            <h2>{{pageTitle}}</h2>
            <details-template :user-data="user" :user-type="userType" ref="details" @ready="onDetailsTemplateReady"/>
            <actions-panel v-if="detailsEdited" :actions="actions"  @save="saveChanges" @discard="discardChanges" />
            <error-scroll-mover />
        </template>
    </div>
</template>

<script>
import { mapState } from 'vuex';
import { DetailsTemplate } from '@/components/Details';
import { PanelActions } from '@/constants/ui/details';
import ActionsPanel from '@bloomio/spa-admin-common/components/actions-panel';
import ErrorScrollMover from '@/components/ErrorScrollMover';

/**
 * Details info for any user category
 */
export default {
    components: {
        DetailsTemplate,
        ActionsPanel,
        ErrorScrollMover,
    },
    beforeCreate() {
        // clear old data from store and send request to server for new user details
        this.$store.commit('clearCurrentDetails');
        this.initLoading(this.$store.dispatch('getUserById', this.$route.params.userId).then(() => {
            this.dataIsLoaded = true;
        }));
    },
    watch: {
        user(newVal) {
            const {
                user_id: userId, email, account_type: accountType, startup_company: companyName,
            } = newVal;
            if (newVal.account_type === 'startup') {
                document.title = `${this.capitalize(accountType)}: ${userId} ${companyName} ${email}`;
            } else {
                document.title = `${this.capitalize(accountType)}: ${userId} ${this.fullName} ${email}`;
            }
        },
    },
    data() {
        return {
            dataIsLoaded: false,
            domReady: false,
            actions: [...PanelActions],
        };
    },
    computed: {
        hasToken: vm => vm.$store.getters.token,
        ...mapState({
            user: state => state.users.current_details, // server user details
        }),
        detailsEdited: vm => vm.domReady && vm.$store.getters.wereDetailsEdited,
        userType: vm => vm.$store.getters.userDetailsType, // user type: investor, startup, user
        fullName: (vm) => {
            const firstName = vm.user.first_name ? vm.user.first_name : '';
            const lastName = vm.user.last_name ? vm.user.last_name : '';
            return `${firstName} ${lastName}`.trim();
        },
        pageTitle: (vm) => {
            let fname = 'unknown account';
            if (vm.user.account_type) {
                fname = vm.user.account_type === 'startup' ? vm.user.startup_company : `${vm.fullName}`;
                fname = !fname ? `nameless ${vm.user.account_type}` : `${vm.user.account_type} ${fname}`;
            }
            return `Details for the ${fname}`;
        },
    },
    methods: {
        /**
         * Go to listing page or main page (if this page is first)
         */
        goBack() {
            if (this.$router.isFirstPage) {
                this.$router.push('/');
            } else {
                this.$router.go(-1);
            }
        },
        /**
         * Submit new user details
         */
        saveChanges() {
            const actionPromise = this.$store.dispatch('updateUserDetails', {
                userType: this.user.account_type,
                params: { userId: this.user.user_id },
            }).then(() => {
                this.discardChanges();
            });
            this.initLoading(actionPromise);
        },

        /**
         * Discard data changes for form
         * @returns {void}
         */
        discardChanges() {
            this.$refs.details.discardChanges();
        },
        /**
         * Event handler for DetailsTemplate
         * @returns {void}
         */
        onDetailsTemplateReady() {
            this.domReady = true;
        },
        capitalize(str) {
            return str.charAt(0).toUpperCase() + str.slice(1);
        },
    },
};
</script>

<style lang="stylus" scoped>
.details-page
    padding-bottom: 2rem

.details-page__back
    font-size: 1.2rem
    font-weight: bold
    margin-bottom: 2rem

</style>
